/*#============================================================================
 *# Copyright (C) 1991 Recital Corporation Inc.
 *# As an unpublished licenced proprietary work.
 *# All rights reserved worldwide.
 *#============================================================================
 *
 * 	MODULE		: rsi_exa.c
 *
 * 	PURPOSE		: RSI Example gateway.
 *
 * 	AUTHOR		: Recital Corpexation Inc.
 *
 * 	DATE		: 18-Nov-2002
 *
 *===========================================================================*/
#include <stdio.h>
#include <ctype.h>

#include "rsi.h"

/* Forward references to functions specified in the server table */
int     db_server_start();
int     db_server_stop();
int     db_server_connect();
int     db_server_disconnect();
int     db_server_declare();
int	db_server_undeclare();
int     db_server_open();
int     db_server_close();
int     db_server_execsql();
int     db_server_count();
int     db_server_delete();
int     db_server_find();
int     db_server_insert();
int     db_server_read();
int     db_server_update();
int     db_server_maperror();
int     db_server_fetch();
int     db_server_fetchmany();
int	db_server_commit();
int	db_server_rollback();
int	db_server_attach();
int	db_server_detach();
int	db_server_execute();
int	db_server_use();
int	db_server_unuse();
int	db_server_zap();
int	db_server_fieldlist();
int	db_server_tablelist();
int     db_server_islocked();
int     db_server_lock();
int     db_server_unlock();
int     db_server_islocked_table();
int     db_server_lock_table();
int     db_server_rlock_table();
int     db_server_unlock_table();
int     db_server_extended_fetch();
int     db_server_memo();

/* Functions that handle table operations for this SQL server */
static	struct	RSI_SERVER_TABLE db_server_table = {
	db_server_start,
	db_server_stop,
	db_server_connect,
	db_server_disconnect,
	db_server_declare,
	db_server_undeclare,
	db_server_open,
	db_server_close,
	db_server_execsql,
	db_server_count,
	db_server_delete,
	db_server_find,
	db_server_insert,
	db_server_read,
	db_server_update,
	db_server_maperror,
	db_server_fetch,
	db_server_fetchmany,
	db_server_commit,
	db_server_rollback,
	db_server_attach,
	db_server_detach,
	db_server_execute,
	db_server_use,
	db_server_unuse,
	db_server_zap,
	db_server_fieldlist,
	db_server_tablelist,
	db_server_islocked,
	db_server_lock,
	db_server_unlock,
	db_server_islocked_table,
	db_server_lock_table,
	db_server_rlock_table,
	db_server_unlock_table,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	NULL,
	db_server_extended_fetch,
	db_server_memo,
};

static	FILE	*exafp = NULL;

/*=============================================================================
 *
 * Recital/EXA_server main program entry point.
 *
 *===========================================================================*/

main(argc, argv)
int	argc;
char	*argv[];
{
	rsi_server("exa", argc, argv, &db_server_table);
	exit(1);
}



#ifndef OPENVMS

void	closedebug()
{
	if (exafp != NULL) {
	    fclose(exafp);
	}
}

/*=============================================================================
 *
 * D E B U G F
 *
 * Debuging function.
 *
 *===========================================================================*/

int	debugf(s, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10)
char	*s;
int	arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10;
{
	if (exafp == NULL) exafp = fopen("example.txt","w");

	fprintf(exafp, s, arg1, arg2, arg3, arg4, arg5, arg6,
		arg7, arg8, arg9);
	fflush(exafp);
	return(0);
}

#endif
